#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#define _REENTRANT

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "generator.h"

extern GtkWidget *maindialog;
int freq = 1000;
gdouble min = 50, max = 4500;

void
on_freq_hscale_value_changed           (GtkRange        *range,
                                        gpointer         user_data)
{
	freq = (int)gtk_range_get_value(range);
	generator_set_freq(0, freq);
}


void
on_minfreq_spinbutton_value_changed    (GtkSpinButton   *spinbutton,
                                        gpointer         user_data)
{
	min = gtk_spin_button_get_value(spinbutton);
	if (min < max) {
		gtk_range_set_range(GTK_RANGE(lookup_widget(maindialog, "freq_hscale")),
				min, max);
	}
}


void
on_maxfreq_spinbutton_value_changed    (GtkSpinButton   *spinbutton,
                                        gpointer         user_data)
{
	max = gtk_spin_button_get_value(spinbutton);
	if (min < max) {
		gtk_range_set_range(GTK_RANGE(lookup_widget(maindialog, "freq_hscale")),
				min, max);
	}
}


void
on_play_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

	/****
	 ****                   T H E R E    I S
	 ****
	 ****    ####     #####     ##  ##     #####      ####
	 ****    ####     ##  ##    ##  ##    ##          ####
	 ****     ##      #####     ##  ##    ##  ###      ## 
	 ****             ##  ##    ##  ##    ##   ##         
	 ****     ##      #####      ####      #####       ## 
	 ****
	 ****
	 ****      Bug is somewhere in alsa initialisation...
	 ****          Something want to be initialised.
	 ***/

	/* BUG workaround */
	static int first = 1;
	if (first) {
		generator_start(0, NULL, freq);
		generator_stop(0);
		first = 0;
	}

	gtk_widget_set_sensitive(lookup_widget(maindialog, "play_button"), 0);
	gtk_widget_set_sensitive(lookup_widget(maindialog, "stop_button"), 1);
	generator_start(0, NULL, freq);
}


void
on_stop_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_set_sensitive(lookup_widget(maindialog, "play_button"), 1);
	gtk_widget_set_sensitive(lookup_widget(maindialog, "stop_button"), 0);
	generator_stop(0);
}


void
on_close_button_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_main_quit();
}


void
on_maindialog_close                    (GtkDialog       *dialog,
                                        gpointer         user_data)
{
	gtk_main_quit();
}


void
on_maindialog_destroy                  (GtkObject       *object,
                                        gpointer         user_data)
{
	gtk_main_quit();
}

